#include "../lang/Object.h"
#include "ArrayList.h"

using namespace baygui::lang;
using namespace baygui::util;

/** vCx[gϐ̏s܂B*/
void ArrayList::initialize()
{
    this->_elements = new Object*[defaultCapacity];
    this->_size = 0;
    this->_capacity = defaultCapacity;
}

/** ftHgRXgN^ */
ArrayList::ArrayList()
{
    initialize();
}

/** fXgN^ */
ArrayList::~ArrayList()
{
    delete [] this->_elements;
}

/** Xg̎w肳ꂽʒuɁAw肳ꂽvf}܂B*/
bool ArrayList::add(Object* o)
{
    if (this->_size == this->_capacity)
    {
        /* ȂȂeʂ{ɑ₷ */
        this->_capacity <<= 1;
        Object** ptr = new Object*[this->_capacity];
        for (int i = 0; i < this->_size; i++)
        {
            ptr[i] = this->_elements[i];
        }
        delete [] this->_elements;
        this->_elements = ptr;
    }
    this->_elements[this->_size] = o;
    this->_size++;
    return true;
}

/** Xg炷ׂĂ̗vf폜܂B*/
void ArrayList::clear()
{
    delete [] this->_elements;
    initialize();
}

/** XgɎw̗vfꍇ true Ԃ܂B*/
bool ArrayList::contains(Object* elem)
{
    return indexOf(elem) != -1;
}

/** Xg̎w肳ꂽʒuɂvfԂ܂B*/
Object* ArrayList::get(int index)
{
    return (index < 0) ? NULL : this->_elements[index];
}

/** w肳ꂽƓe̗vf擪猟܂B*/
int ArrayList::indexOf(Object* elem)
{
    for (int i = 0; i < this->_size; i++)
    {
        if (this->_elements[i]->equals(elem)) return i;
    }
    return -1;
}

/** C++ ɂ[ instanceof */
bool ArrayList::instanceof(int classType)
{
    return Object::instanceof(classType) ||
           (bayos_util_ArrayList == classType);
}

/** XgɗvfȂǂ𔻒肵܂B*/
bool ArrayList::isEmpty()
{
    return this->_size == 0;
}

/** Xg̎w肳ꂽʒuvf폜܂B*/
Object* ArrayList::remove(int index)
{
    if (index < 0) return NULL;
    this->_size--;
    Object* obj = this->_elements[index];
    for (int i = index; i < this->_size; i++)
    {
        this->_elements[i] = this->_elements[i + 1];
    }
    return obj;
}

/** Xgɂvf̐Ԃ܂B*/
int ArrayList::size()
{
    return this->_size;
}

/** XĝׂĂ̗vfŊi[ĂzԂ܂B*/
Object** ArrayList::toArray()
{
    return this->_elements;
}
