#include "../bayos.h"

/* RXgN^ */
Message::Message()
{
    type = from = arg1 = arg2 = arg3 = len = 0;
    data = NULL;
}

/* fXgN^ */
Message::~Message()
{
    delete data;
}

/* bZ[W̐ */
Message* Message::create(int type, int arg1, int arg2, int arg3, int len, byte* data)
{
    Message* e = new Message();
    e->type = type;
    e->from = Scheduler::current->id;
    e->arg1 = arg1;
    e->arg2 = arg2;
    e->arg3 = arg3;
    e->len  = len;
    if (len > 0) {
        e->data = new byte[len];
        memcpy(e->data, data, len);
    } else {
        e->data = NULL;
    }
    return e;
}

/* bZ[W̑M */
void Message::send(int to, Message* msg)
{
    Scheduler::task_list[to]->fifo->add(msg);
}
